<?php

declare(strict_types=1);

/*
 * Chill is a software for social workers
 *
 * For the full copyright and license information, please view
 * the LICENSE file that was distributed with this source code.
 */

namespace Chill\PersonBundle\Repository\SocialWork;

use Chill\PersonBundle\Entity\SocialWork\SocialIssue;
use Doctrine\ORM\EntityManagerInterface;
use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\NonUniqueResultException;
use Doctrine\ORM\NoResultException;
use Doctrine\ORM\QueryBuilder;
use Doctrine\Persistence\ObjectRepository;
use Symfony\Component\HttpFoundation\RequestStack;

final readonly class SocialIssueRepository implements ObjectRepository
{
    private EntityRepository $repository;

    public function __construct(private EntityManagerInterface $entityManager, private RequestStack $requestStack)
    {
        $this->repository = $entityManager->getRepository(SocialIssue::class);
    }

    public function find($id): ?SocialIssue
    {
        return $this->repository->find($id);
    }

    /**
     * @return array<int, SocialIssue>
     */
    public function findAll(): array
    {
        return $this->repository->findAll();
    }

    public function findAllOrdered(): array
    {
        return $this->repository->createQueryBuilder('si')
            ->orderBy('si.ordering', 'ASC')
            ->getQuery()
            ->getResult();
    }

    /**
     * @return array|SocialIssue[]
     */
    public function findAllActive(): array
    {
        return $this->buildQueryWithDesactivatedDateCriteria()->getQuery()->getResult();
    }

    /**
     * @param mixed|null $limit
     * @param mixed|null $offset
     *
     * @return array<int, SocialIssue>
     */
    public function findBy(array $criteria, ?array $orderBy = null, $limit = null, $offset = null): array
    {
        return $this->repository->findBy($criteria, $orderBy, $limit, $offset);
    }

    public function findOneBy(array $criteria, ?array $orderBy = null): ?SocialIssue
    {
        return $this->repository->findOneBy($criteria, $orderBy);
    }

    /**
     * @return class-string
     */
    public function getClassName(): string
    {
        return SocialIssue::class;
    }

    public function getResult(
        QueryBuilder $qb,
        ?int $start = 0,
        ?int $limit = 50,
        ?array $orderBy = [],
    ): array {
        $qb->select('si');

        $qb
            ->setFirstResult($start)
            ->setMaxResults($limit);

        foreach ($orderBy as $field => $direction) {
            $qb->addOrderBy('si.'.$field, $direction);
        }

        return $qb->getQuery()->getResult();
    }

    private function getLang(): string
    {
        return $this->requestStack->getCurrentRequest()?->getLocale() ?? 'fr';
    }

    private function queryByTitle(string $pattern): QueryBuilder
    {
        $qb = $this->entityManager->createQueryBuilder()->from(SocialIssue::class, 'si');

        $qb
            ->where($qb->expr()->like('LOWER(UNACCENT(JSON_EXTRACT(si.title, :lang)))', "CONCAT('%', LOWER(UNACCENT(:pattern)), '%')"))
            ->setParameter('pattern', $pattern)
            ->setParameter('lang', $this->getLang());

        return $qb;
    }

    public function buildFilterBaseQuery(?string $queryString, array $isActive): QueryBuilder
    {
        if (null !== $queryString) {
            $qb = $this->queryByTitle($queryString);
        } else {
            $qb = $this->entityManager->createQueryBuilder()->from(SocialIssue::class, 'si');
        }

        $now = new \DateTime('now');
        if (in_array('Active', $isActive, true) && !in_array('Inactive', $isActive, true)) {
            $qb->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->isNull('si.desactivationDate'),
                    $qb->expr()->gt('si.desactivationDate', ':now')
                )
            )->setParameter('now', $now);
        } elseif (in_array('Inactive', $isActive, true) && !in_array('Active', $isActive, true)) {
            $qb->andWhere(
                $qb->expr()->andX(
                    $qb->expr()->isNotNull('si.desactivationDate'),
                    $qb->expr()->lte('si.desactivationDate', ':now')
                )
            )->setParameter('now', $now);
        }

        return $qb;
    }

    /**
     * @return array<int, SocialIssue>
     */
    public function findFilteredSocialIssues(
        ?string $queryString = null,
        array $isActive = ['active'],
        ?int $start = 0,
        ?int $limit = 50,
        ?array $orderBy = ['ordering' => 'ASC'],
    ): array {
        $qb = $this->buildFilterBaseQuery($queryString, $isActive);

        return $this->getResult($qb, $start, $limit, $orderBy);
    }

    public function countFilteredSocialIssues(
        ?string $queryString = null,
        array $isActive = ['active'],
    ): int {
        $qb = $this->buildFilterBaseQuery($queryString, $isActive);

        try {
            return $qb
                ->select('COUNT(si)')
                ->getQuery()->getSingleScalarResult();
        } catch (NoResultException|NonUniqueResultException $e) {
            throw new \LogicException('a count query should return one result', previous: $e);
        }
    }

    private function buildQueryWithDesactivatedDateCriteria(): QueryBuilder
    {
        $qb = $this->repository->createQueryBuilder('si');

        $qb->where('si.desactivationDate is null')
            ->orWhere('si.desactivationDate > :now')
            ->orderBy('si.ordering', 'ASC')
            ->setParameter('now', new \DateTime('now'));

        return $qb;
    }
}
